;****************************************************
;   LCD ÷ (ڿ   Ʈ )   *
;****************************************************
;
RS	BIT	P2.0
RW	BIT	P2.1
CE	BIT	P2.2
;
	ORG	00H		; α׷ 
	JMP	START
;
START:	MOV	SP,#50H		;  
LCD_INITIALIZE:			; LCD ʱȭ
; 
	MOV	A,#38H	        ;  Ʈ(8Ʈ, 5X7 Ʈ, 2 ) 
	CALL	CMD_WRITE	; 3ȸ ؼ    (ù°) 
	CALL	DELAY
;
	CALL	CMD_WRITE	; ι°  
	CALL	DELAY
;
	CALL	CMD_WRITE	; ° 
	CALL	DELAY
;
	MOV	A,#06H		; Ʈ Ʈ (巹 , Ʈ )
	CALL	CMD_WRITE  
; 
	MOV	A,#0EH		; ǥ (ǥ on, Ŀ on,  off)
	CALL	CMD_WRITE
; 
LOOP:	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
;
	MOV	A,#80H		; DD RAM 巹 Ʈ(1 1 ĭ ̵)
	CALL	CMD_WRITE
;
	MOV	DPTR,#MSG01	; ù°  μ⸦   ּ 
	CALL	LCD_MSG		; ù°  μ
;
	MOV	A,#0C0H		; DD RAM 巹 Ʈ(2 1 ĭ ̵)
	CALL	CMD_WRITE
; 
	MOV	DPTR,#MSG02	; ι°  μ⸦   ּ 	 
	CALL	LCD_MSG		; ι°  μ
        CALL	DELAY
        CALL	DELAY
        CALL	DELAY
;
	MOV	R0,#05H		;  ݺȸ
ONF1:	CALL	DELAY		; ȭ 0.5  
        CALL	DELAY
	MOV	A,#08H		; DISPLAY off
	CALL	CMD_WRITE	;
	CALL	DELAY
        CALL	DELAY
	MOV	A,#0CH		; DISPLAY on
	CALL	CMD_WRITE
	DJNZ	R0,ONF1
;
	MOV	R0,#16		; Ʈ ݺȸ
LSHT:	CALL	DELAY
	MOV	A,#18H		;  Ʈ
	CALL	CMD_WRITE
	DJNZ	R0,LSHT
;
	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
;
	MOV	A,#80H		; DD RAM 巹 Ʈ(1 1 ĭ ̵)
	CALL	CMD_WRITE	;
;
	MOV	DPTR,#MSG01	; ù°  μ⸦   ּ 
	CALL	LCD_MSG		; ù°  μ
;
	MOV	A,#0C0H		; DD RAM 巹 Ʈ(2 1 ĭ ̵)
	CALL	CMD_WRITE	;
; 
	MOV	DPTR,#MSG02 	; ι°  μ⸦   ּ 
	CALL	LCD_MSG 	; ι°  μ
        CALL	DELAY
        CALL	DELAY
        CALL	DELAY
;
	MOV	R0,#05H		;  ݺȸ
ONF2:	CALL	DELAY		; ȭ 0.5  
        CALL	DELAY
	MOV	A,#08H		; DISPLAY off
	CALL	CMD_WRITE
	CALL	DELAY
        CALL	DELAY
	MOV	A,#0CH		; DISPLAY on
	CALL	CMD_WRITE
	DJNZ	R0,ONF2
;
	MOV	R0,#16		; Ʈ ݺȸ
RSHT:	CALL	DELAY
	MOV	A,#1CH		;  Ʈ
	CALL	CMD_WRITE
	DJNZ	R0,RSHT		; R0ŭ ݺ
	JMP	LOOP
;
CMD_WRITE:			; ɾ 
	MOV	P1,A      	; 8051 --> LCD 
	CLR	RS        	; RS=L (Instruction)
	CLR	RW        	; R/W=L (Write)
	NOP             	;  
	SETB	CE        	; LCD  ο̺ 
	NOP             	;  
	NOP             	; 
	CLR	CE        	; LCD  𽺿̺ 
	CALL	LCD_BUSY  	;  ÷ ˻ƾ  
	RET             	;  
;
DATA_WRITE:			;  
	MOV	P1,A      	; 8051 --> LCD  
	SETB	RS        	; RS=H (Data) 
	CLR	RW        	; R/W=L (Write) 
	NOP             	;  
	SETB	CE        	; LCD  ο̺ 
	NOP             	;  
	NOP             	; 
	CLR	CE        	; LCD  𽺿̺ 
	CALL	LCD_BUSY  	;  ÷ ˻ƾ  
	RET             	; 
;  
LCD_BUSY:			; BUSY üũ
	CLR	CE		; LCD  𽺿̺ 
	SETB	P1.7		; P1.7=H 
	SETB	RW		; R/W=H (Read)
	CLR	RS		; RS=L (Instruction)
LB1:	CLR	CE		; LCD  𽺿̺ 
	SETB	CE		; LCD  ο̺
	JB	P1.7,LB1	;   ˻
	CLR	CE		;  ƴϸ LCD 𽺿̺ 
	RET			; 
;
LCD_MSG: 
	CLR	A		; Acc=0
	MOVC	A,@A+DPTR	; DPTR  ġ ͸ 
	INC	DPTR		; DPTR 
	JZ	LCD_MSG9	; 0̸   ǹ 
	CALL	DATA_WRITE	; LCD ͸  ƾ 
	JMP	LCD_MSG		;  ͸  ƾ  
LCD_MSG9:
	RET			; 
;
DELAY:				; ƾ
	MOV	R2,#00H
DLY1:	MOV	R1,#00H
DLY2:	NOP
	DJNZ	R1,DLY2
	DJNZ	R2,DLY1
	RET
;
MSG01:	DB	'VIVE LA COREA',00H	;   , 00H   ǹ
MSG02:	DB	'2010 WORLDCUP!',00H	; ϴ  
	END				; α׷ 