;****************************************************
;         LCD ÷ (ѱ ÷)          *
;         CG RAM ̿  ̼ Ʈ ǥ           *
;****************************************************
;
RS	BIT	P2.0
RW	BIT	P2.1
CE	BIT	P2.2
;
	ORG	0000H		; α׷ 
	JMP	START
;
START:	MOV	SP,#50H		;  
LCD_INITIALIZE:			; LCD ʱȭ
	MOV	A,#38H	        ; ǼƮ (8Ʈ, 5X7 Ʈ, 2 )
	CALL	CMD_WRITE	; 3ȸ ؼ    (ù°)
	CALL	DELAY		; 
	CALL	CMD_WRITE	; ι° 
	CALL	DELAY
	CALL	CMD_WRITE	; ° 
	CALL	DELAY
;
	MOV	A,#06H		; Ʈ Ʈ (巹 , Ʈ )
	CALL	CMD_WRITE  
	MOV	A,#0CH		; ǥ (ǥ on, Ŀ off,  off)
	CALL	CMD_WRITE
	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
	CALL	CMD_WRITE
;
	MOV	A,#40H		; CG RAM 巹 Ʈ(00H)
	CALL	CMD_WRITE	;   ߻
;
	MOV	R2,#64		;    
	MOV	DPTR,#FONT_DATA	;  ּ 
J1:	CLR	A		; Acc=0
        MOVC	A,@A+DPTR	; DPTR  ġ ͸ 
	INC	DPTR		; DPTR 
	CALL	DATA_WRITE	;  
	DJNZ	R2,J1		; CG   ˻
;
;	MOV	A,#01H		; ȭ , Ŀ Ȩ ġ
;	CALL	CMD_WRITE
	MOV	A,#80H		; DD RAM 巹 Ʈ(00H = 1 1 ĭ ̵)
	CALL	CMD_WRITE	;
	MOV	DPTR,#MSG01	; ù°  μ⸦   ּ 
	CALL	LCD_MSG		; ù°  μ
	MOV	A,#0C0H		; DD RAM 巹 Ʈ(40H = 2 1 ĭ ̵)
	CALL	CMD_WRITE
	MOV	DPTR,#MSG02 	; ι°  μ⸦   ּ 
	CALL	LCD_MSG 	; ι°  μ
;
LOOP:	NOP
	JMP	LOOP
;
CMD_WRITE:			; ɾ 
	MOV	P1,A      	; 8051 --> LCD
	CLR	RS        	; RS=L (Instruction)
	CLR	RW        	; R/W=L (Write)
	NOP             	; 
	SETB	CE        	; LCD  ο̺
	NOP             	; 
	NOP
	CLR	CE        	; LCD  𽺿̺
	CALL	LCD_BUSY  	;  ÷ ˻ƾ 
	RET             	; 
;
DATA_WRITE:			;  
	MOV	P1,A      	; 8051 --> LCD
	SETB	RS        	; RS=H (Data)
	CLR	RW        	; R/W=L (Write)
	NOP             	; 
	SETB	CE        	; LCD  ο̺
	NOP             	; 
	NOP
	CLR	CE        	; LCD  𽺿̺
	CALL	LCD_BUSY  	;  ÷ ˻ƾ 
	RET             	;  
;  
LCD_BUSY:
	CLR	CE		; LCD  𽺿̺
	SETB	P1.7		; P1.7=H
	SETB	RW		; R/W=H (Read)
	CLR	RS		; RS=L (Instruction)
LB1:	CLR	CE		; LCD  𽺿̺
	SETB	CE		; LCD  ο̺
	JB	P1.7,LB1	;   ˻
	CLR	CE		;  ƴϸ LCD 𽺿̺
	RET			; 
;
LCD_MSG: 
	CLR	A		; Acc=0
	MOVC	A,@A+DPTR	; DPTR  ġ ͸ 
	INC	DPTR		; DPTR 
	INC	A		; Acc 
	JZ	END_D		; 0̸   ǹ
	DEC	A		; Acc 
	CALL	DATA_WRITE	; LCD ͸  ƾ 
	JMP	LCD_MSG		;  ͸  ƾ 
END_D:	RET			; 
;
DELAY:				; ƾ
	MOV	R1,#00H
DLY1:	MOV	R0,#00H
DLY2:	NOP
	DJNZ	R0,DLY2
	DJNZ	R1,DLY1
	RET
;
; 鼮 Ʈ 
FONT_DATA:
	DB	00H,00H,0FH,08H,08H,08H,08H,00H		; ܺ Ʈ
	DB	00H,02H,1AH,0AH,0AH,0AH,0AH,00H
	DB	00H,00H,00H,01H,02H,04H,08H,00H
	DB	00H,10H,10H,08H,04H,02H,01H,00H
;
	DB	08H,08H,08H,08H,0FH,00H,00H,00H		; ϴܺ Ʈ
	DB	0AH,0AH,0AH,0AH,1AH,02H,00H,00H
	DB	00H,00H,00H,00H,0FH,00H,00H,00H
	DB	10H,10H,10H,10H,1FH,00H,00H,00H
;
MSG01:	DB	00H,01H,02H,03H,0FFH	;   , 0FFH   ǹ
MSG02:	DB	04H,05H,06H,07H,0FFH	; ϴ  
	END				; α׷ 
