;****************************************************
;            DS1620 ̿ µġ           *
;****************************************************
;
DS_DQ	BIT	P1.0		; DS1620   
DS_CLK	BIT	P1.1		; DS1620 CLK
DS_RST	BIT	P1.2		; DS1620 RST
MINUS	BIT	P1.3		;  Ǵ  ǥ
DEGR	BIT	P1.4		; Ҽ  ǥ(0 Ǵ 5)
;
	ORG     0000H		; α׷ 
;
START:
	MOV     A,#0CH		;  Ϳ ͸  
	CALL	DS_WRITE
	MOV     A,#02H		;  Ϳ   ( ۸)
	CALL	DS_WRITE
	CALL    DELAY		; 
;
	MOV     A,#01H		; TH Ϳ ͸  
	CALL	DS_WRITE
	MOV	B,#00H		; µ(00H), Ͽµ(01H)
	MOV	A,#38H		; TH(28)
	CALL	DS_WRITE_9BIT
	CALL    DELAY		; 
;
	MOV     A,#02H		; TL Ϳ ͸  
	CALL	DS_WRITE
	MOV	B,#00H		; µ(00H), Ͽµ(01H)
	MOV	A,#34H		; TL(26)
	CALL	DS_WRITE_9BIT
	CALL    DELAY		; 
;
	MOV     A,#22H		; µȯ 
	CALL	DS_WRITE
	MOV     A,#0EEH         ; µȯ 
	CALL	DS_WRITE
	CALL    DELAY
;
READ_TEMP:
	MOV     A,#0AAH         ; µ д 
	CALL	DS_WRITE
	CALL	DS_READ		; µ (R2=Data, R3=Sign Bit)
;
	CJNE    R3,#00H,BELOW	; R3    Ϸ и
	SETB    MINUS		;  ǥ
	JMP	ABOVE
;
BELOW:
	CLR     MINUS		;  ǥ
	MOV     A,R2
	CPL     A		; 2  ȯ
	INC     A
	MOV	R2,A
;
ABOVE:
	MOV     A,R2
	MOV     B,#2
	DIV     AB
	MOV     R0,B		; B: Ҽ  
;
	MOV     B,#10
	DIV     AB		; A = 10 ڸ µ, B = 1 ڸ µ
	RL	A		;  4Ʈ ̵
	RL	A
	RL	A
	RL	A
	ORL	A,B		; P2 ϱ  
	MOV     P2,A		; µ 
;
	CJNE    R0,#00H,NOT_Z	; Ҽ  ǥÿ 
	CLR     DEGR		; Ҽ  ǥ(.0)
	JMP     READ_TEMP
;
NOT_Z:
	SETB    DEGR		; Ҽ  ǥ(0.5)
	JMP     READ_TEMP
;
DS_WRITE: 			; ɾ (8051-->DS1620)
        CLR     DS_RST		; RST=L
        SETB    DS_CLK		; CLK=H
        MOV     R0,#08H
        SETB    DS_RST		; RST=H
WR_LOOP:
        RRC     A
        MOV     DS_DQ,C
        CLR     DS_CLK		; CLK=0
        NOP
        SETB    DS_CLK		; CLK=1
        NOP
        DJNZ    R0,WR_LOOP
	RET
;
DS_WRITE_9BIT: 			; 9Ʈ  (8051-->DS1620)
        CLR     DS_RST		; RST=L
        SETB    DS_CLK		; CLK=H
        MOV     R0,#08H
        SETB    DS_RST		; RST=H
WR9_LOOP:
        RRC     A
        MOV     DS_DQ,C
        CLR     DS_CLK		; CLK=0
        NOP
        SETB    DS_CLK		; CLK=1
        NOP
        DJNZ    R0,WR9_LOOP
;
	MOV	A,B		; ȣƮ
	RLC	A
        MOV     DS_DQ,C
        CLR     DS_CLK		; CLK=0
        NOP
        SETB    DS_CLK		; CLK=1
        NOP
	RET
;
DS_READ: 			;  б(DS1620 -> 8051)
	SETB	DS_RST		; RST=H
        SETB    DS_CLK		; CLK=H
	MOV     R0,#08H		; Ÿֵ̹  ķ µ 
RD_LOOP:
	CLR	DS_CLK		; CLK=L
	MOV	C,DS_DQ		; Input One Bit of Data
        SETB	DS_CLK		; CLK=H
        RRC	A		; Shift Right with Carry
        DJNZ    R0,RD_LOOP	; Check End of data
	MOV	R2,A		; R2=Data
;
	CLR	A
        CLR     DS_CLK		; CLK=L
        MOV     C,DS_DQ
        SETB    DS_CLK		; CLK=H
	RLC	A
        MOV     R3,A		; R3=Sign Bit
	RET
;
DELAY:				; ð 
	MOV     R6,#00H
DLY1:	MOV     R5,#00H
DLY2:	NOP
	DJNZ    R5,DLY2
	DJNZ    R6,DLY1
	RET
        END			; α׷ 
