// ť LED ÷(4x4x4 3D Cube)

#include <reg51.h>

unsigned char f_time;
char *ptr;				// 

code unsigned char ALL_OFF[]={0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
code unsigned char ALL_ON[]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};

code unsigned char PTRN11[]={0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00};
code unsigned char PTRN12[]={0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00};
code unsigned char PTRN13[]={0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x00};

code unsigned char PTRN21[]={0xa5,0xa5,0x5a,0x5a,0xa5,0xa5,0x5a,0x5a};
code unsigned char PTRN22[]={0x5a,0x5a,0xa5,0xa5,0x5a,0x5a,0xa5,0xa5};

code unsigned char PTRN31[]={0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x88};
code unsigned char PTRN32[]={0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc,0xcc};
code unsigned char PTRN33[]={0xee,0xee,0xee,0xee,0xee,0xee,0xee,0xee};
code unsigned char PTRN34[]={0x77,0x77,0x77,0x77,0x77,0x77,0x77,0x77};
code unsigned char PTRN35[]={0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33};
code unsigned char PTRN36[]={0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11};

void delay(unsigned char i)
{
	while(i--);
}

void display(void)
{
	unsigned char i, j, scan;
	char *str;

	for (i=0; i<=f_time; i++) {
		str=ptr;
		scan=0x01;
		for (j=0; j<=3; j++) {
			P1=*str;		// Ʈ 1-2
			str++;
			P3=*str;		// Ʈ 3-4
			str++;
			P2=scan;		// ĵ  
			scan=scan<<1;		//  1Ʈ Ʈ
			delay(40);		// 
		}
	}
}

void main(void)
{
	unsigned char i;

	P2=0x00;				//  LED off
	do {
		f_time=0x3f;
		ptr=PTRN11;			//  1 ÷
		display();			// ÷
		ptr=PTRN12;
		display();
		ptr=PTRN13;
		display();
		ptr=ALL_ON;
		display();
		ptr=PTRN13;
		display();
		ptr=PTRN12;
		display();
		ptr=PTRN11;
		display();
		ptr=ALL_OFF;			//  LED off
		display();

		for (i=0; i<=4; i++) {		//  2 ÷
			ptr=PTRN21;
			display();		// ÷
			ptr=PTRN22;
			display();
		}

		ptr=PTRN31;			//  3 ÷
		display();			// ÷
		ptr=PTRN32;
		display();
		ptr=PTRN33;
		display();
		ptr=ALL_ON;
		display();
		ptr=PTRN34;
		display();
		ptr=PTRN35;
		display();
		ptr=PTRN36;
		display();
		ptr=ALL_OFF;			//  LED off
		display();
	} while(1);
}