// LCD ÷ (ܼ ڿ ÷ϱ)

#include <reg51.h>

sbit RS=P2^0;
sbit RW=P2^1;
sbit CE=P2^2;
sbit busy_flag=P1^7;

code unsigned char MSG01[] = {"VIVE LA COREA"};
code unsigned char MSG02[] = {"2010 WORLDCUP!"};

void delay(unsigned int i)    	// ð Լ
{
	while(i--);
}

void lcd_busy(void)		//  ÷ ˻
{
unsigned char busy;

	CE=0;			// LCD 𽺿̺
	busy_flag=1;		// P1.7=High
	RW=1;			// R/W=High(Read)
	RS=0;			// LCD_RS=Low(Instruction)
	do{
		busy=P1;
		CE=0;
		CE=1;
	} while(busy&=0x80);
	CE=0;			// LCD 𽺿̺
}

void cmd_write(unsigned char Command)	// ɾ 
{
	P1=Command;		// 8051LCD
	RS=0;			// LCD_RS=Low(Instruction)
	RW=0;			// R/W=Low(Write)
	CE=1;			// LCD ο̺
	CE=0;			// LCD 𽺿̺
	lcd_busy();		//  ÷ ˻ Լ ȣ
}

void data_write(unsigned char Data)	//  
{
	P1=Data;		// 8051LCD
	RS=1;			// LCD_RS=High(Data)
	RW=0;			// R/W=Low(Write)
	CE=1;			// LCD ο̺
	CE=0;			// LCD 𽺿̺
	lcd_busy();		//  ÷ ˻ Լ ȣ
}

void lcd_initialze(void)	// LCD ʱȭ
{
	cmd_write(0x38);	//  (8Ʈ, 57Ʈ, 2)
	delay(0x200);		// ù ° (4.1ms ̻)
	cmd_write(0x38);
	delay(0x08);		//  ° (100us ̻)
	cmd_write(0x38);
	cmd_write(0x0c);	// ÷  ɾ(÷ on, Ŀ off,  off)
	cmd_write(0x06);	// Ʈ  (巹 , Ʈ )
	cmd_write(0x01);	// ÷ Ŭ, Ŀ Ȩ ġ
}

void lcd_msg(void)
{
unsigned char i;
	cmd_write(0x80);			// DDRAM 巹 (1 1 ̵)
	for (i=0; MSG01[i] != 0; i++)
  		data_write(MSG01[i]);		// 1࿡ ޽ ÷
	cmd_write(0xc0);			// DDRAM 巹 (2 1 ̵)
	for (i=0; MSG02[i] != 0; i++)
  		data_write(MSG02[i]);		//2࿡ ޽ ÷
}

void main(void)
{
	lcd_initialze();		// LCD ʱȭ
	lcd_msg();			// ޽ ÷
	while(1);
}