// LCD ÷ (ѱ ÷)

#include <reg51.h>

sbit RS=P2^0;
sbit RW=P2^1;
sbit CE=P2^2;
sbit busy_flag=P1^7;

code unsigned char font[]={
		0x00,0x00,0x0f,0x08,0x08,0x08,0x08,0x00,	// ܺ  
		0x00,0x02,0x1a,0x0a,0x0a,0x0a,0x0a,0x00,
		0x00,0x00,0x00,0x01,0x02,0x04,0x08,0x00,
		0x00,0x10,0x10,0x08,0x04,0x02,0x01,0x00,
		0x08,0x08,0x08,0x08,0x0f,0x00,0x00,0x00,	// ϴܺ  
		0x0a,0x0a,0x0a,0x0a,0x1a,0x02,0x00,0x00,
		0x00,0x00,0x00,0x00,0x0f,0x00,0x00,0x00,
		0x10,0x10,0x10,0x10,0x1f,0x00,0x00,0x00};


code unsigned char MSG01[]={0x00,0x01,0x02,0x03};
code unsigned char MSG02[]={0x04,0x05,0x06,0x07};

void delay(unsigned int i)    	// ð  Լ
{
	while(i--);
}

void lcd_busy(void)		//  ÷ ˻
{
unsigned char busy;

	CE=0;			// LCD 𽺿̺
	busy_flag=1;		// P1.7=High
	RW=1;			// R/W=High(Read)
	RS=0;			// LCD_RS=Low(Instruction)
	do{
		busy=P1;
		CE=0;
		CE=1;
	} while(busy&=0x80);
	CE=0;			// LCD 𽺿̺
}

void cmd_write(unsigned char Command)	// ɾ 
{
	P1=Command;		// ɾ 
	RS=0;			// LCD_RS=Low(Instruction)
	RW=0;			// R/W=Low(Write)
	CE=1;			// LCD ο̺
	CE=0;			// LCD 𽺿̺
	lcd_busy();		//  ÷ ˻ Լ ȣ
}

void data_write(unsigned char Data)	//  
{
	P1=Data;		//  
	RS=1;			// LCD_RS=High(Data)
	RW=0;			// R/W=Low(Write)
	CE=1;			// LCD Enable
	CE=0;			// LCD disable
	lcd_busy();		//  ÷ ˻ Լ ȣ
}

void lcd_initialze(void)	// LCD ʱȭ
{
	cmd_write(0x38);	//  (8Ʈ, 57Ʈ, 2)
	delay(0x0200);		// ù ° (4.1ms ̻)
	cmd_write(0x38);
	delay(0x08);		//  ° (100us ̻)
	cmd_write(0x38);
	cmd_write(0x0c);	// ÷  ɾ(÷ on, Ŀ off,  off)
	cmd_write(0x06);	// Ʈ  (巹 , Ʈ )
	cmd_write(0x01);	// ÷ Ŭ, Ŀ Ȩ ġ
}

void lcd_msg(void)
{
unsigned char i;
	cmd_write(0x80);		// DDRAM 巹 (1 1 ̵)
	for (i=0; i<=3; i++)
  		data_write(MSG01[i]);	// 1࿡ ޽ ÷
	cmd_write(0xc0);		// DDRAM 巹 (2 1 ̵)
	for (i=0; i<=3; i++)
  		data_write(MSG02[i]);		// 2࿡ ޽ ÷
}

void cgram_write(void)
{
unsigned char i;
	cmd_write(0x40);		// CGRAM 巹 (00H)
	for (i=0; i<=63; i++)
  		data_write(font[i]);	// CGRAM  
}

void main(void)
{
	lcd_initialze();	// LCD ʱȭ
	cgram_write();		// CGRAM    
	lcd_msg();		// ޽ ÷
	while(1);
}