;****************************************************
;              HS1101 ̿                *
;****************************************************
;
	ORG	0000H		; α׷ 
	JMP	START
;
        ORG     001BH		; Ÿ̸ ͷƮ 
        JMP     TMR1_INT
;
START:
        MOV     TMOD,#00010101B	; Ÿ̸/ī1(Ÿ̸  1)
        MOV     TH1,#3CH	; Ÿ̸/ī0(ī  1)
        MOV     TL1,#0B0H	;  (0.05), 65536-50000=0x3CB0
        MOV     TH0,#00H	; ī ʱⰪ = 0000H
        MOV     TL0,#00H
        MOV     R4,#20		; ݺ (20x0.05=1)
;
        SETB    ET1		; Ÿ̸ 1 ο̺
        SETB    ET0		; ī 0 ο̺
        SETB    EA		; ü ͷƮ ο̺
        SETB    TR1		; Ÿ̸ 1 RUN
        SETB    TR0		; ī 0 RUN
	JMP	$
;
TMR1_INT:			; ͷƮ ó ƾ
        CLR     EA		; ͷƮ 𽺿̺
        DJNZ    R4,NOTSEC	; 1 ˻
        CALL    HUM_PROC
;
        MOV     TH0,#00H	; ī  = 0
        MOV     TL0,#00H
        MOV     R4,#20		; ݺ
;
NOTSEC:
        MOV     TH1,#3CH	;  缳(0.05)
        MOV     TL1,#0B0H
        SETB    EA		; ͷƮ ο̺
        RETI			; ͷƮ 
;
HUM_PROC:			;  
        MOV	A,TH0		; ļ Ʈ R3 
        MOV	R3,A
        MOV	A,TL0		; ļ Ʈ R2 
        MOV	R2,A
;
        MOV	R5,#00H		; ȯǥ  = 00H
        MOV	DPTR,#HUM_TBL	; ȯǥ ʱ ּ = DPTR
LOOP:
	CLR	A
        MOVC	A,@A+DPTR	; ȯǥ Ʈ 
	MOV	R1,A		; R1 
	CLR	A
	INC	DPTR
        MOVC	A,@A+DPTR	; ȯǥ Ʈ 
	MOV	R0,A		; R0 
	CALL	SUB16		; ȯǥ - ļ
	JC	DISPLAY		; ȯǥ  < ļ ?
	INC	DPTR		; DPTR 
	INC	R5		; ȯǥ  
	CJNE	R5,#101,LOOP	; 100% ˻
	DEC	R5
;
DISPLAY:			;  7-׸Ʈ ǥ
	MOV	A,R5
	MOV	B,#10
	DIV	AB
	ORL     A,#0F0H		; 10 Ϻ ׸Ʈ 
	MOV	P1,A		; 10  ǥ
	CLR	P1.4		; 4511 ͸ ġ
	SETB	P1.4
;
	MOV	A,B
	ORL     A,#0F0H		; 1 Ϻ ׸Ʈ 
	MOV	P1,A		; 1  ǥ
	CLR	P1.5		; 4511 ͸ ġ
	SETB	P1.5
	RET
;
; 16-Bit  
; D(R1,R0) = X(R1,R0) - Y(R3,R2)
;
SUB16:	MOV	A,R0		; X Ʈ A 
	CLR	C		; CY=0
	SUBB	A,R2		; R0 - R2
	MOV	R0,A		;  R0 
	MOV	A,R1		; X Ʈ A 
	SUBB	A,R3		; R1 - R3
	MOV	R1,A		;  R1 
	RET
;
HUM_TBL:			;  ļ 
	DW      1CF1H,1CDFH,1CCEH,1CBCH,1CABH	; 0 - 4 %
	DW	1C9BH,1C8AH,1C7AH,1C6AH,1C5AH	; 5 - 9 %
	DW	1C4BH,1C3BH,1C2CH,1C1EH,1C0FH	; 10 - 14 %
	DW      1C00H,1BF2H,1BE4H,1BD6H,1BC8H	; 15 - 19 %
	DW	1BBBH,1BADH,1BA0H,1B92H,1B85H	; 20 - 24 %
	DW      1B78H,1B6BH,1B5FH,1B52H,1B45H	; 25 - 29 %
	DW	1B39H,1B2CH,1B20H,1B14H,1B08H	; 30 - 34 %
	DW      1AFBH,1AEFH,1AE3H,1AD7H,1ACBH	; 35 - 39 %
	DW	1ABFH,1AB3H,1AA7H,1A9BH,1A8FH	; 40 - 44 %
	DW      1A84H,1A78H,1A6CH,1A60H,1A54H	; 45 - 49 %
	DW	1A48H,1A3CH,1A30H,1A24H,1A18H	; 50 - 54 %
	DW      1A0BH,19FFH,19F3H,19E7H,19DAH	; 55 - 59 %
	DW	19CEH,19C1H,19B5H,19A8H,199BH	; 60 - 64 %
	DW      198EH,1981H,1974H,1967H,195AH	; 65 - 69 %
	DW	194DH,193FH,1932H,1924H,1916H	; 70 - 74 %
	DW      1909H,18FBH,18EDH,18DEH,18D0H	; 75 - 79 %
	DW	18C1H,18B3H,18A4H,1895H,1886H	; 80 - 84 %
	DW      1877H,1868H,1858H,1849H,1839H	; 85 - 89 %
	DW	1829H,1819H,1809H,17F9H,17E8H	; 90 - 94 %
	DW      17D8H,17C7H,17B6H,17A5H,1793H	; 95 - 99 %
        END			; α׷ 
