// ǻ  (䳢)

#include <reg51.h>

sbit speaker=P2^0;
unsigned char time_data, tone_data;
code unsigned char tone_tbl[]={0x33,0x3d,0x3d,0x33,0x3d,0x4d,0x44,0x3d,0x44,
				0x4d,0x3d,0x33,0x25,0x33,0x25,0x33,0x25,0x33,
				0x3d,0x33,0x44,0x39,0x3d,0x44,0x4d,0x00};

code unsigned char time_tbl[]={16,8,8,8,8,16,16,8,8,8,8,16,
            			12,4,12,4,8,8,16,16,8,8,8,8,16,0};

void delay(unsigned char i)
{
	while(i--);
}

void display(void)
{
	switch(tone_data) {
		case 0x4d: P1=0xff; P3=0xfd; break;	// LED 1 on
		case 0x44: P1=0xff; P3=0xfc; break;	// LED 2 on
		case 0x3d: P1=0x7f; P3=0xfc; break;	// LED 3 on
		case 0x39: P1=0x3f; P3=0xfc; break;	// LED 4 on
		case 0x33: P1=0x1f; P3=0xfc; break;	// LED 5 on
		case 0x2d: P1=0x0f; P3=0xfc; break;	// LED 6 on
		case 0x28: P1=0x07; P3=0xfc; break;	// LED 7 on
		case 0x25: P1=0x03; P3=0xfc; break;	// LED 8 on
		case 0x21: P1=0x01; P3=0xfc; break;	// LED 9 on
		default: P1=0x00; P3=0xfc; break;	// LED 10 on
	}
}

void sound(void)
{
	do {
		speaker=1;		// Ŀ on
		delay(tone_data);
		speaker=0;		// Ŀ off
		delay(tone_data);
	} while(time_data);
}

void no_sound(void)
{
	speaker=0;			// Ŀ off
	P1=0xff;			//  LED off
	P3=0xff;
	while(time_data);
}

void TMR0_int(void) interrupt 1		// Ÿ̸/ī 0 ͷƮ ͹ȣ = 1
{
	time_data--; 

	TH0=0x59;			//  缳
	TL0=0x8b;
	return;
}

void main(void)
{
	unsigned char i;

	TMOD=0x01;			// Ÿ̸0 1 
	TH0=0x59;			// 1/16ڿ شϴ  
	TL0=0x8b;; 			// (65536-42613)=598BH
	ET0=1;				// Ÿ̸0 ͷƮ ο̺
	EA=1;				// ü ͷƮ ο̺
	PT0=1;				// Ÿ̸0 ͷƮ 켱 High
	TR0=1;				// Ÿ̸0 ͷƮ run

	do {
		for (i=0; ;i++) {
			tone_data=tone_tbl[i];		// ļ 
			time_data=time_tbl[i];		//  
			if (time_data==0) break;	//   ˻
			if (tone_data==0) no_sound();
			else {
				display();		// LED onϴ Լ
				sound();		// Ҹ ߻ Լ
			 }
		}
	} while(1);
}