// MCP3202 ̿ A/D ȯ

#include <reg51.h>

sbit CS=P1^0;
sbit DIN=P1^1;
sbit DOUT=P1^2;
sbit CLK=P1^3;
sbit segment_10=P2^4;
sbit segment_01=P2^5;

void display(unsigned int N)
{
	unsigned char N10, N1;

	N10=N/10;
	N1=N%10;

	P2=N1 | 0xf0;		// 1 ȯ ÷
	segment_01=0;		//  ġ
	segment_01=1;

	P2=N10 | 0xf0;		// 10 ȯ ÷
	segment_10=0;		//  ġ
	segment_10=1;
}

unsigned int MCP3202(void)
{
	unsigned char i;
	unsigned int ADC_value=0;

	CLK=0;			// ʱȭ
	DIN=0;			// ʱȭ

	CS=0;			// Ĩ 
	DIN=1;			//  Ʈ
	CLK=1;
	CLK=0;

	DIN=1;			// SGL/DIFF=1, Single ended mode
	CLK=1;
	CLK=0;

	DIN=0;			// ODD/SIGN=0, CH0 
	CLK=1;
	CLK=0;

	DIN=1;			// MSBF=1, MSB 
	CLK=1;
	CLK=0;

	DIN=0;			//  Ʈ
	CLK=1;
	CLK=0;

	for (i=0; i<12; i++) {		// ADC(12 bit) ȯ  
		ADC_value=ADC_value<<1;
		CLK=1;
		if (DOUT==1) ADC_value=ADC_value | 0x01;
		CLK=0;
	}
	CS=1;
	CLK=1;
	return ADC_value;
}

void main(void)
{
	unsigned long result=0;

	do {
		result=MCP3202();
		result=(result*50)/4096;
		display(result);
	} while(1);
}